// Code generated by mockery v2.12.1. DO NOT EDIT.

package mocks

import (
	dao "gitlab.informatika.org/rahmahkn/if3250_2022_03_ensiklo/internal/app/model/dao"
	dto "gitlab.informatika.org/rahmahkn/if3250_2022_03_ensiklo/internal/app/model/dto"

	mock "github.com/stretchr/testify/mock"

	testing "testing"
)

// UserService is an autogenerated mock type for the UserService type
type UserService struct {
	mock.Mock
}

// CreateUser provides a mock function with given fields: user
func (_m *UserService) CreateUser(user dto.CreateUserRequestDTO) (dto.UserDTO, error) {
	ret := _m.Called(user)

	var r0 dto.UserDTO
	if rf, ok := ret.Get(0).(func(dto.CreateUserRequestDTO) dto.UserDTO); ok {
		r0 = rf(user)
	} else {
		r0 = ret.Get(0).(dto.UserDTO)
	}

	var r1 error
	if rf, ok := ret.Get(1).(func(dto.CreateUserRequestDTO) error); ok {
		r1 = rf(user)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetUser provides a mock function with given fields: id
func (_m *UserService) GetUser(id uint64) (dao.User, error) {
	ret := _m.Called(id)

	var r0 dao.User
	if rf, ok := ret.Get(0).(func(uint64) dao.User); ok {
		r0 = rf(id)
	} else {
		r0 = ret.Get(0).(dao.User)
	}

	var r1 error
	if rf, ok := ret.Get(1).(func(uint64) error); ok {
		r1 = rf(id)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetUserByEmail provides a mock function with given fields: email
func (_m *UserService) GetUserByEmail(email string) (dao.User, error) {
	ret := _m.Called(email)

	var r0 dao.User
	if rf, ok := ret.Get(0).(func(string) dao.User); ok {
		r0 = rf(email)
	} else {
		r0 = ret.Get(0).(dao.User)
	}

	var r1 error
	if rf, ok := ret.Get(1).(func(string) error); ok {
		r1 = rf(email)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// Login provides a mock function with given fields: loginRequest
func (_m *UserService) Login(loginRequest dto.LoginRequest) (dto.LoginResponse, error) {
	ret := _m.Called(loginRequest)

	var r0 dto.LoginResponse
	if rf, ok := ret.Get(0).(func(dto.LoginRequest) dto.LoginResponse); ok {
		r0 = rf(loginRequest)
	} else {
		r0 = ret.Get(0).(dto.LoginResponse)
	}

	var r1 error
	if rf, ok := ret.Get(1).(func(dto.LoginRequest) error); ok {
		r1 = rf(loginRequest)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// NewUserService creates a new instance of UserService. It also registers the testing.TB interface on the mock and a cleanup function to assert the mocks expectations.
func NewUserService(t testing.TB) *UserService {
	mock := &UserService{}
	mock.Mock.Test(t)

	t.Cleanup(func() { mock.AssertExpectations(t) })

	return mock
}
